SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!
SystemOrganization addCategory: #Phidget!
SystemOrganization addCategory: #'Phidget-Core'!
SystemOrganization addCategory: #'Phidget-Lab'!

Object subclass: #PhidPhidget
	instanceVariableNames: 'semaphores processBlocks opened'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhidPhidget subclass: #PhidInterfaceKit
	instanceVariableNames: 'ifKit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:15'!
close
	"close the interfaceKit Phidget"
	opened ifFalse: [^ self]. "already closed"
	self primClose: ifKit.
	opened := false.
	self unregisterSemaphores.! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/23/2009 13:20'!
initialize
	super initialize.
	semaphores
		add: #SensorChange->Semaphore new;
		add: #InputChange->Semaphore new;
		add: #OutputChange->Semaphore new.
		
	processBlocks
		add: #SensorChange->[];
		add: #InputChange->[];
		add: #OutputChange->[].
		
	opened := false.
	ifKit := self primCreate.! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:10'!
onInputChangeDo: aBlock
	processBlocks at: #InputChange put: aBlock.! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:10'!
onOutputChangeDo: aBlock
	processBlocks at: #OutputChange put: aBlock.! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:10'!
onSensorChangeDo: aBlock
	processBlocks at: #SensorChange put: aBlock.! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/23/2009 08:12'!
openAny
	"opens any InterfaceKit Phidget"
	ifKit ifNil: [self error:'Could not open InterfaceKit!!'. ^ self].
	self registerSemaphores.
	self primOpenAny: ifKit.
	opened := true.
	[self callbackProcess: #Attach] fork.
	[self callbackProcess: #Detach] fork.
	[self callbackProcess: #Error] fork.
	[self callbackProcess: #SensorChange] fork.
	[self callbackProcess: #InputChange] fork.
	[self callbackProcess: #OutputChange] fork.! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:31'!
primClose: phid
	"close the interfaceKit Phidget"
	<primitive: 'primIfKitClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:32'!
primCreate
	"reset the interfaceKit Phidget (Semaphores and Handle)"
	<primitive: 'primIfKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:47'!
primOnAttach: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnAttach' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:48'!
primOnDetach: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnDetach' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:48'!
primOnError: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnError' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:47'!
primOnInputChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnInputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:47'!
primOnOutputChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnOutputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:47'!
primOnSensorChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	<primitive: 'primIfKitOnSensorChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:44'!
primOpen: phid withSerial: serial
	"opens the phidget with the given serialNumber InterfaceKit Phidget"
	<primitive: 'primIfKitOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:45'!
primOpenAny: phid
	"opens any available InterfaceKit Phidget"
	<primitive: 'primIfKitOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'primitives' stamp: 'pt 4/22/2009 15:45'!
primSensorValue: phid At: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"
	<primitive: 'primIfKitSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 16:46'!
registerSemaphores
	| semaIndex |
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#SensorChange).
	self primOnSensorChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#InputChange).
	self primOnInputChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#OutputChange).
	self primOnOutputChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#Attach).
	self primOnAttach: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#Detach).
	self primOnDetach: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: (semaphores at:#Error).
	self primOnError: ifKit SemaphoreIndex: semaIndex! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 15:32'!
sensorValue: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"

	sensorIndex >= 1 & sensorIndex<=8
		ifTrue:[^ self primSensorValue: ifKit At: sensorIndex-1].
	^ nil! !

!PhidInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:16'!
unregisterSemaphores

	semaphores do: [:sema |
		sema signal.
		Smalltalk unregisterExternalObject: sema]! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/23/2009 13:09'!
callbackProcess: aSymbol
	(semaphores at: aSymbol) wait.
	[opened] whileTrue: [
		(processBlocks at: aSymbol) value.
		(semaphores at: aSymbol) wait].! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/23/2009 13:20'!
initialize
	super initialize.
	semaphores := Dictionary new.
	semaphores
		add: #Attach->Semaphore new;
		add: #Detach->Semaphore new;
		add: #Error->Semaphore new.
		
	processBlocks := Dictionary new.
	processBlocks
		add: #Attach->[];
		add: #Detach->[];
		add: #Error->[].! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 20:40'!
lastError
	^ self primLastError! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:11'!
onAttachDo: aBlock
	processBlocks at: #Attach put: aBlock.! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:12'!
onDetachDo: aBlock
	processBlocks at: #Detach put: aBlock.! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 18:12'!
onErrorDo: aBlock
	processBlocks at: #Error put: aBlock.! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 20:40'!
primLastError
	"Returns last Error Code"
	<primitive: 'primLastError' module: 'PhidgetPlugin'>
	^ nil! !

!PhidPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 16:39'!
registerSemaphores

	self subclassResponsibility.! !

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 11:12'!
ifKitValueOf: oop
	"Return a pointer to the first byte of the Phidget_ifKit record within the given Smalltalk bytes object, or nil if oop is not a Phidget_ifKit record."

	self returnTypeC: 'Phidget_ifKit *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(Phidget_ifKit)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget_ifKit *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'pt 4/23/2009 08:01'!
initialiseModule
	"Initialise the module"
	self export: true.
	^ self cCode: '(sqInt) phidgetPlugin_Initialise()' inSmalltalk:[true]! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'pt 4/22/2009 11:11'!
phidgetValueOf: oop
	"Return a pointer to the first byte of the Phidget record within the given Smalltalk bytes object, or nil if oop is not a Phidget record."

	self returnTypeC: 'Phidget *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(Phidget)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 15:08'!
primIfKitAttached: ifKitHandle
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitAttached' parameters: #(Oop ).
	phid := self ifKitValueOf: ifKitHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_Attached((Phidget *)phid)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:26'!
primIfKitClose: phidHandle
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitClose' parameters: #(Oop ).
	phid := self ifKitValueOf: phidHandle.
	^ self cCode: 'phidgetIfKit_Close(phid)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:27'!
primIfKitCreate
	| phidOop phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy classByteArray indexableSize: (self cCode: 'sizeof(Phidget_ifKit)').
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKit_ResetSemaphores(phid)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 15:08'!
primIfKitOnAttach: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnAttach' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetOnAttachSemaIndex((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 15:08'!
primIfKitOnDetach: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnDetach' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetOnDetachSemaIndex((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 15:08'!
primIfKitOnError: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnError' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetOnErrorSemaIndex((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:20'!
primIfKitOnInputChange: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnInputChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_SetOnInputChangeSemaIndex(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:20'!
primIfKitOnOutputChange: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnOutputChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_SetOnOutputChangeSemaIndex(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:21'!
primIfKitOnSensorChange: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnSensorChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_SetOnSensorChangeSemaIndex(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:30'!
primIfKitOpen: phidOop withSerial: serial
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOpen' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKit_Open(phid, (int)serial)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:29'!
primIfKitOpenAny: phidOop
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOpenAny' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [self cCode: 'phidgetIfKit_OpenAny(phid)'].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:31'!
primIfKitSensorValue: phidHandle At: index
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitSensorValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_GetSensorValue(phid, (int)index)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 20:35'!
primLastError
	self primitive: 'primLastError' parameters: #( ).
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_LastError()')! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'pt 4/23/2009 08:01'!
shutdownModule
	"Shutdown the module"
	self export: true.
	^self cCode: '(sqInt) phidgetPlugin_Shutdown()' inSmalltalk:[true]! !

BorderedMorph subclass: #IfKitSlider
	instanceVariableNames: 'pick max min maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:32'!
initialize
	super initialize.
	self color: Color blue lighter;
		width: 50;
		height: 200.
	pick := BorderedMorph new.
	pick color: Color black;
		width: 40;
		height: 20.
	self addMorph: pick.
	pick
		left: (self left + 5);
		top: (self top + 5).
	min := 0.
	max := (self bottom -5)-(self top +5)-pick height.
	minValue :=0.
	maxValue :=100.
	! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:31'!
rawValue: aNumber
	"0 <= aNumber <= 1000"
	"pick top: self bottom - 5 - pick height - (aNumber/1000*max)."
	pick top: self top + 5 + ((1000-aNumber)/1000*max)! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:10'!
setMin: minV max: maxV
	minValue := minV.
	maxValue := maxV.! !

!IfKitSlider methodsFor: 'as yet unclassified' stamp: 'pt 4/20/2009 11:12'!
value
	^ (pick top - self top -5)*maxValue/minValue! !
